//+------------------------------------------------------------------
//|                                                          
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  PaleVioletRed
#property indicator_color2  DimGray
#property indicator_width1  2
#property indicator_style2  STYLE_DOT

//
//
//
//
//

extern int TrixPeriod   = 5;
extern int TrixPrice    = PRICE_CLOSE;
extern int SignalPeriod = 8;

//
//
//
//
//

double TrixBuffer[];
double SignBuffer[];
double work[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,TrixBuffer);
   SetIndexBuffer(1,SignBuffer);
   SetIndexBuffer(2,work);

   //
   //
   //
   //
   //

   IndicatorShortName("Trix ("+TrixPeriod+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int limit,i,counted_bars=IndicatorCounted();


   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit  = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      work[i] = iEma(iEma(iEma(MathLog(iMA(NULL,0,1,0,MODE_SMA,TrixPrice,i)),TrixPeriod,i,0),TrixPeriod,i,1),TrixPeriod,i,2);
         if (work[i+1]!=0)
              TrixBuffer[i] = 10000*(work[i]-work[i+1])/work[i+1];
         else TrixBuffer[i] = 0.00;
         SignBuffer[i] = iLinr(TrixBuffer[i],SignalPeriod,i,0);
   }   

   //
   //
   //
   //
   //

   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double workEma[][3];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArraySize(workEma)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}
//
//
//
//
//

double workLinr[][1];
double iLinr(double price, double period, int r, int instanceNo=0)
{
   if (ArraySize(workLinr)!= Bars) ArrayResize(workLinr,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
   
      period = MathMax(period,1);
      workLinr[r][instanceNo] = price;
         double lwmw = period; double lwma = lwmw*price;
         double sma  = price;
         for(int k=1; k<period && (r-k)>=0; k++)
         {
            double weight = period-k;
                   lwmw  += weight;
                   lwma  += weight*workLinr[r-k][instanceNo];  
                   sma   +=        workLinr[r-k][instanceNo];
         }             
   
   return(3.0*lwma/lwmw-2.0*sma/period);
}